package syscon.arbutus.product.services.legal.contract.dto;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Set;

import syscon.arbutus.product.services.core.contract.dto.CommentType;

/**
 * The representation of the case info type.
 * CaseInfoType serves the purpose to carry the minimal needed information about the case.
 *
 * @author lhan
 */
public class CaseInfoType implements Serializable {

    private static final long serialVersionUID = -72545729942960900L;

    private Long caseId;
    @NotNull
    private CaseIdentifierType primaryCaseIdentifier;
    private boolean saveAsSecondaryIdentifier;
    private List<CaseIdentifierType> caseIdentifiers;
    @NotNull
    private String caseCategory;
    @NotNull
    private String caseType;
    private Date createdDate;
    private Date issuedDate;
    @NotNull
    private Long facilityId;
    @NotNull
    private Long supervisionId;
    private boolean isActiveFlag;
    private String statusChangeReason;
    private String sentenceStatus;
    private CommentType comment;

    private String issuingFacilityName;

    private Set<String> dataPrivileges;

    /**
     * Check if properties are set properly. An empty string is treated as null.
     * <p>supervisionId, facilityId, caseCategory, caseType,  are not null. </p>
     *
     * @return boolean Return true if all required properties are set, false otherwise.
     */
    @Deprecated
    public boolean isWellFormed() {

        if (primaryCaseIdentifier == null || ValidationUtil.isEmpty(supervisionId) || ValidationUtil.isEmpty(facilityId) || ValidationUtil.isEmpty(caseCategory)
                || ValidationUtil.isEmpty(caseType)) {
			return false;
		}

        return true;
    }

    /**
     * Verify if properties are set properly.
     * <p>Max length of caseCategory is 64.</p>
     * <p>Max length of caseType is 64.</p>
     * <p>Max length of StatusChangeReason is 64.</p>
     * <p>Max length of sentenceStatus is 64.</p>
     *
     * @return boolean Return true if all required properties are set and all values are valid, false otherwise.
     */
    @Deprecated
    public boolean isValid() {

        if (!isWellFormed()) {
			return false;
		}

        if (primaryCaseIdentifier != null && !primaryCaseIdentifier.isValid()) {
			return false;
		}

        if (comment != null && !comment.isValid()) {
			return false;
		}

        if (caseIdentifiers != null) {
            for (CaseIdentifierType dto : caseIdentifiers) {
                if (dto == null || !dto.isValid()) {
					return false;
				}
            }
        }

        if (!ValidationUtil.isValidCode(caseCategory)) {
			return false;
		}

        if (!ValidationUtil.isValidCode(caseType)) {
			return false;
		}

        if (!ValidationUtil.isValidCode(statusChangeReason)) {
			return false;
		}

        if (!ValidationUtil.isValidCode(sentenceStatus)) {
			return false;
		}

        return true;
    }

    /**
     * @return the caseId
     */
    public Long getCaseId() {
        return caseId;
    }

    /**
     * The unique Id of each case object. It is generated by service and should not be changed by client.
     *
     * @param caseId the caseId to set
     */
    public void setCaseId(Long caseId) {
        this.caseId = caseId;
    }

    /**
     * @return the primaryCaseIdentifier
     */
    public CaseIdentifierType getPrimaryCaseIdentifier() {
        return primaryCaseIdentifier;
    }

    /**
     * The primary CaseIdentifier recorded for a case. (Required)
     *
     * @param primaryCaseIdentifier the primaryCaseIdentifier to set
     */
    public void setPrimaryCaseIdentifier(CaseIdentifierType primaryCaseIdentifier) {
        this.primaryCaseIdentifier = primaryCaseIdentifier;
    }

    /**
     * @return the saveAsSecondaryIdentifier
     */
    public boolean isSaveAsSecondaryIdentifier() {
        return saveAsSecondaryIdentifier;
    }

    /**
     * When update primary case identifier, if this value is true, then service saves the old primary case identifier to secondary identifier list.
     *
     * @param saveAsSecondaryIdentifier the saveAsSecondaryIdentifier to set
     */
    public void setSaveAsSecondaryIdentifier(boolean saveAsSecondaryIdentifier) {
        this.saveAsSecondaryIdentifier = saveAsSecondaryIdentifier;
    }

    /**
     * A list of additional CaseIdentifier objects recorded for a case. (optional)
     *
     * @return the caseIdentifiers
     */
    public List<CaseIdentifierType> getCaseIdentifiers() {
        return caseIdentifiers;
    }

    /**
     * @param caseIdentifiers the caseIdentifiers to set
     */
    public void setCaseIdentifiers(List<CaseIdentifierType> caseIdentifiers) {
        this.caseIdentifiers = caseIdentifiers;
    }

    /**
     * @return the caseCategoryCode
     */
    public String getCaseCategory() {
        return caseCategory;
    }

    /**
     * The category of the case, e.g. InJurisdiction case, Out of Jurisdiction case.
     * The value should be one of the reference code in the CaseCategory reference set.  (required)
     *
     * @param caseCategory the caseCategory to set
     */
    public void setCaseCategory(String caseCategory) {
        this.caseCategory = caseCategory;
    }

    /**
     * @return the caseTypeCode
     */
    public String getCaseType() {
        return caseType;
    }

    /**
     * Indicates the type of case eg. immigration, traffic, criminal.
     * The value should be one of the reference code in the CaseType reference set.  (required)
     *
     * @param caseType the caseType to set
     */
    public void setCaseType(String caseType) {
        this.caseType = caseType;
    }

    /**
     * @return the createdDate
     */
    public Date getCreatedDate() {
        return createdDate;
    }

    /**
     * The date/time when the case was first created. It is set to the current system date by system. (ignored)
     *
     * @param createdDate the createdDate to set
     */
    public void setCreatedDate(Date createdDate) {
        this.createdDate = createdDate;
    }

    /**
     * @return the issuedDate
     */
    public Date getIssuedDate() {
        return issuedDate;
    }

    /**
     * The date on which the case was issued (by the court) (optional)
     *
     * @param issuedDate the issuedDate to set
     */
    public void setIssuedDate(Date issuedDate) {
        this.issuedDate = issuedDate;
    }

    /**
     * @return the facilityId
     */
    public Long getFacilityId() {
        return facilityId;
    }

    /**
     * Used to indicate the originating facility name, type and location for a case.
     * Static reference to the Facility service. (required)
     *
     * @param facilityId the facilityId to set
     */
    public void setFacilityId(Long facilityId) {
        this.facilityId = facilityId;
    }

    /**
     * @return the supervisionId
     */
    public Long getSupervisionId() {
        return supervisionId;
    }

    /**
     * Id to a Supervision period. Static reference to the Supervision service. (required)
     *
     * @param supervisionId the supervisionId to set
     */
    public void setSupervisionId(Long supervisionId) {
        this.supervisionId = supervisionId;
    }

    /**
     * @return the isActiveFlag
     */
    public boolean isActiveFlag() {
        return isActiveFlag;
    }

    /**
     * Indicates whether the case is active or inactive. This is specifically set by the user, not derived. (required)
     *
     * @param isActiveFlag the isActiveFlag to set
     */
    public void setActiveFlag(boolean isActiveFlag) {
        this.isActiveFlag = isActiveFlag;
    }

    /**
     * @return the caseReactiveReasonCode
     */
    public String getStatusChangeReason() {
        return statusChangeReason;
    }

    /**
     * Indicates the reason a case status was reactivated
     * The value should be one of the reference code in the CaseStatusChangeReason reference set.  (optional)
     *
     * @param StatusChangeReason the StatusChangeReason to set
     */
    public void setStatusChangeReason(String statusChangeReason) {
        this.statusChangeReason = statusChangeReason;
    }

    /**
     * @return the sentenceStatusCode
     */
    public String getSentenceStatus() {
        return sentenceStatus;
    }

    /**
     * Indicates whether the offender was sentenced to be incarcerated.
     * The value should be one of the reference code in the SentenceStatus reference set. (optional)
     *
     * @param sentenceStatus the sentenceStatus to set
     */
    public void setSentenceStatus(String sentenceStatus) {
        this.sentenceStatus = sentenceStatus;
    }

    /**
     * Gets the value of the comment property.
     *
     * @return CommentType - The comments associated to a Case
     */
    public CommentType getComment() {
        return comment;
    }

    /**
     * Sets the value of the comment property.
     *
     * @param comment CommentType - The comments associated to a Case
     */
    public void setComment(CommentType comment) {
        this.comment = comment;
    }

    /**
     * @return the issuingFacilityName
     */
    public String getIssuingFacilityName() {
        return issuingFacilityName;
    }

    /**
     * This is the facility name issued the Case. It is for display only. (Ignored)
     *
     * @param issuingFacilityName the issuingAuthority to set
     */
    public void setIssuingFacilityName(String issuingFacilityName) {
        this.issuingFacilityName = issuingFacilityName;
    }

    /**
     * @return the dataPrivileges
     */
    public Set<String> getDataPrivileges() {
        return dataPrivileges;
    }

    /**
     * This is used for data privileges against the business object.
     * If the service is not subjected to data privileges it is expected
     * that this property is still presented with an empty set.
     * If the service is not subjected to data privileges and
     * the consumer tries to set data into this property the setter
     * will ignore the input without error.
     *
     * @param dataPrivileges the dataPrivileges to set
     */
    public void setDataPrivileges(Set<String> dataPrivileges) {
        this.dataPrivileges = dataPrivileges;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return "CaseInfoType [getCaseId()=" + getCaseId() + ", getPrimaryCaseIdentifier()=" + getPrimaryCaseIdentifier() + ", getCaseIdentifiers()="
                + getCaseIdentifiers() + ", getCaseCategory()=" + getCaseCategory() + ", getCaseType()=" + getCaseType() + ", getCreatedDate()=" + getCreatedDate()
                + ", getIssuedDate()=" + getIssuedDate() + ", getFacilityId()=" + getFacilityId() + ", getSupervisionId()=" + getSupervisionId() + ", isActiveFlag()="
                + isActiveFlag() + ", getStatusChangeReason()=" + getStatusChangeReason() + ", getSentenceStatus()=" + getSentenceStatus() + ", getComment()="
                + getComment() + ", getIssuingFacilityName()=" + getIssuingFacilityName() + ", getDataPrivileges()=" + getDataPrivileges() + "]";
    }

}
